import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class PlayerWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PlayerWorld extends World
{
    public static final int sizeX = 600;
    public static final int sizeY = 400;
    public static final int blockSize = 10;
    public int NormalTerrainHeight = 15;
    public Selector cursor = new Selector();
    sun sun = new sun();
    
    /**
     * Constructor for objects of class PlayerWorld.
     * 
     */
    public PlayerWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(sizeX, sizeY, 1);
        generateTerrain();
        spawnPlayer();
        this.addObject(cursor, -1, -1);
        this.addObject(new light(), 1, 1);
        this.addObject(sun, 1, 1);
        setPaintOrder(Selector.class, Player.class, Block.class);
    }
    
    public void generateTerrain()
    {
        generateHills(4);
    }
    
    public void generateHills(int minHigh)
    {
        int x = 0;
        int y = NormalTerrainHeight;
        int prevY = 0;
        int random = 3;
        while (x < sizeX / blockSize)
        {
           random = Greenfoot.getRandomNumber(3) - 1 + prevY;
           y = y - random;
           while(y > sizeY / blockSize - minHigh)
           {
               y--;
           }
           this.addObject(new grass(), x * blockSize  + (blockSize / 2), y * blockSize + (blockSize / 2));
           int trans = 0;  
           while (y < sizeY / blockSize / .6)  
           {  
              y++;  
              Dirt dirt = new Dirt();  
              GreenfootImage tint = new GreenfootImage(10, 10);  
              tint.fill();  
              tint.setTransparency(trans);  
              dirt.getImage().drawImage(tint, 0, 0);  
              addObject(dirt, x * blockSize  + (blockSize / 2), y * blockSize  + (blockSize / 2));  
              trans = trans+40;  
              if (trans > 255) trans = 255;  
           }  
           x++;
           prevY = random;
           y = NormalTerrainHeight;
        }
    }
    
    public void spawnPlayer()
    {
        this.addObject(new Player(), 0,0);
    }
    
    public Block getTopBlock(int x)
    {
        int y = 0; 
        while(getObjectsAt(x, y, Block.class).isEmpty())
        {
            y++;
        }
        return ((Block) (getObjectsAt(x, y, Block.class).get(0)));
    }
    
    public void moveCursorTo(int x, int y)
    {
        cursor.goTo(x, y);
    }
    
    public void placeBlock(Block block, int x, int y)
    {
        int RealX = 0;
        while (x > blockSize)
        {
            x -= blockSize;
            RealX++;
        }
        if(x > blockSize/2)
        {
            RealX++;
        }
        
        int RealY = 0;
        while (y > blockSize)
        {
            y -= blockSize;
            RealY++;
        }
        if(y > blockSize/2)
        {
            RealY++;
        }
        
        addObject(block, RealX * blockSize + (blockSize/2), RealY * blockSize + (blockSize/2));
    }
}
